#!/usr/bin/env ruby
if Process.uid == 628 #yhara
  $LOAD_PATH << '/home/yhara/temp/subversion-1.3.2/subversion/bindings/swig/ruby/'
else #www-data
  $LOAD_PATH << '/home/yhara/tmp/subversion-1.3.2/subversion/bindings/swig/ruby/'
end
# copied .libs/*.so to svn/ext/

require 'cgi'
require 'erb'
require 'svn/client'
require 'svn/repos'
require 'config.rb'

class Repotch
  include ERB::Util
  include Configuration
  CSS_URL = ""

  def initialize
  end

  MIN = 60
  HOUR = 60*60
  DAY = 60*60*24
  MONTH = 60*60*24*30
  YEAR = 60*60*24*365
  def how_long(sec)
    case sec
    when 0...MIN
      "#{sec.to_i}秒"
    when MIN...HOUR
      "#{(sec/MIN).to_i}分"
    when HOUR...DAY
      "#{(sec/HOUR).to_i}時間"
    when DAY...(DAY*10)
      "#{'%0.1f' % (sec/DAY)}日"
    when (DAY*10)...MONTH
      "#{(sec/DAY).to_i}日"
    when MONTH...YEAR
      "#{'%.1f' % (sec/MONTH)}ヶ月"
    else
      if sec < 0
        "#{sec}秒"
      else
        "#{sec/YEAR}年#{(sec % YEAR)/MONTH}ヶ月"
      end
    end
  end

  def get_logs(name, start_rev)
    @repos_name = name
    repos = Svn::Repos.open(REPOSITORIES[name] || REPOSITORIES.values.first)
    fs = repos.fs
    @youngest_rev = fs.youngest_rev
    if start_rev.nil? || start_rev.to_i > @youngest_rev
      @start_rev = @youngest_rev
    else
      @start_rev = start_rev.to_i
    end

    n_revs = REVS_PER_PAGE + 1
    @logs = []
    logs = repos.logs("", @start_rev, 0, n_revs) 
    logs.push []
    (logs.size-1).times do |i|
      paths, rev, author, time, comment = *logs[i]

      paths = paths.to_a.sort.reject{|path, info|
        (path == "/" || path == "/trunk") && info.action == "M"
      }
      time_str = time.strftime("%Y/%m/%d %H:%M:%S")
      how_old  = how_long(Time.now - time)
      time_diff = how_long(time - logs[i+1][3]) if logs[i+1][3]
      comment = if comment=="" || comment.nil?
                  EMPTY_COMMENT_MES
                else
                  comment.strip
                end
      @logs << [paths, rev, author, time_str, how_old, time_diff, comment]
    end
    @logs.pop if @logs.size > REVS_PER_PAGE && @logs.last[1] != 0 #revision 0

    self
  end
  
  def diff(rev, path)
    ctx = Svn::Client::Context.new
    out_file = Tempfile.new("svn")
    err_file = Tempfile.new("svn")
    ctx.diff([], path, rev, path, rev+1, out_file.path, err_file.path)
    h out_file.read
  end

  def out
    ERB.new(File.read("template.rhtml")).result(binding)
  end
end

require 'pp'
cgi = CGI.new
cgi.out do 
  begin
    repos_name = cgi.params["repos"][0]
    start_rev = cgi.params["rev"][0] 
    diff_rev = cgi.params["diff"][0]
    path = cgi.params["path"][0]
    if diff_rev
      Repotch.new.diff(diff_rev.to_i, path)
    else
      Repotch.new.get_logs(repos_name, start_rev).out
    end
  rescue Exception => e
    result = "<html><pre>[#{e.type}] #{CGI.escapeHTML e.message}<br>#{e.backtrace.join('<br>')}</pre></html>\n"
  end
end
